function s=legnintabcd(l,m,x,aa,bb,cc,dd)
% l,m is the order of "legendre polynomial" in int(f*leg(j)*leg(k))
% n is the total highest degree of f*leg(j)*leg(k) polynomial of two variable
% x is the degree of f
%aa,bb is the range of x.aa < bb
%cc,dd is the range of y.cc < dd
n=l+m+x;
if mod(n,2)==0
    n1=ceil((n+1)/2);
else
    n1=ceil(n/2);
end
n1;

[A,B]=gauleg(n1);
o=max(l,m);
C=legtable(A,o);
D=C(m+1,:);
E=C(l+1,:);
A1=A*((bb-aa)/2)+(aa+bb)/2;%node
B1=B*(bb-aa)/2;%weight
A2=A*((dd-cc)/2)+(cc+dd)/2;%node
B2=B*(dd-cc)/2;%weight

s=0;

for j=1:n1
    for i=1:n1
      s=s+B2(i)*B1(j)*fun(A1(j),A2(i))*D(i)*E(j);
    end
end
return;
