function b=vectorgbn51(n0,x,x0,c11,listx,listy)
%test correctly for 1;1 2;3 3;2 [-2,2]*[-2,2] [-1,1]*[-2,2] [-1 1/2 1]*[-1 1/2 1]
%compute the vector b in ax=b
%input x (degree of f) and degree of legendre poly(n0)
% when u=g(x,y) in boundary
% x0 is the degree of g(x,y)=.....ex .x+y
% listx:a partition in x-axis
% listy:a partition in y-axis
% ax is the left endpoint of block
% bx is the right endpoint of block
% cx is the down endpoint of block
% dx is the up endpoint of block
n=n0+1;
lex=length(listx);
ley=length(listy);
nitx=lex-1;
nity=ley-1;
b=zeros(1,3*n^2*nitx*nity);
ax=listx(1);
bx=listx(lex);
cx=listy(1);
dx=listy(ley);
% eq1 and 2
if (nitx==1)&&(nity==1)
        a8=zeros(1,n^2);
        a9=zeros(1,n^2);
        a10=zeros(1,n^2);
        for b=0:n0
            for a=0:n0
                a8(a+1+b*(n0+1))=a8(a+1+b*n)+legnint1dgbab(1,1,b,a,x0,cx,dx,ax,bx,cx,dx)-legnint1dgbab(1,-1,b,a,x0,cx,dx,ax,bx,cx,dx);%wrong3 -1,1->cx,dx
                a9(a+1+b*(n0+1))=a9(a+1+b*n)+legnint1dgbab(2,1,a,b,x0,ax,bx,ax,bx,cx,dx)-legnint1dgbab(2,-1,a,b,x0,ax,bx,ax,bx,cx,dx);%wrong4 -1,1->ax,bx
            end
        end

        for l=0:n-1
                for k=0:n-1
                    a10(k+1+(n)*l)=legnintabcd(k,l,x,ax,bx,cx,dx)+c11*(legnint1dgbab(1,1,l,k,x0,cx,dx,ax,bx,cx,dx)+legnint1dgbab(2,1,k,l,x0,ax,bx,ax,bx,cx,dx)+legnint1dgbab(1,-1,l,k,x0,cx,dx,ax,bx,cx,dx)+legnint1dgbab(2,-1,k,l,x0,ax,bx,ax,bx,cx,dx));%wrong5 -1,1->acx,bdx
                end
        end
        for i=(2*(n)^2+1):(3*((n)^2))
            b(i)=a10(i-2*(n)^2);
        end
        for i=(1*(n)^2+1):(2*((n)^2))
            b(i)=a9(i-1*(n)^2);
        end
        for i=(0*(n)^2+1):(1*((n)^2))
            b(i)=a8(i-0*(n)^2);
        end
   
else
        
    for i=1:nity
     for beta=0:n0
         for a=0:n0
             b((i-1)*nitx*n^2+a+1+beta*(n0+1))=-legnint1dgbab(1,-1,beta,a,x0,listy(ley-i),listy(ley-i+1),ax,bx,cx,dx);%left
             b((i*nitx-1)*n^2+a+1+beta*(n0+1))=legnint1dgbab(1,1,beta,a,x0,listy(ley-i),listy(ley-i+1),ax,bx,cx,dx);%right%%listy(ley-i),listy(ley-i+1)S
         end
     end
    end

    for i=1:nitx
     for beta=0:n0
         for a=0:n0
             b((i-1)*n^2+nitx*nity*n^2+a+1+beta*(n0+1))=legnint1dgbab(2,1,a,beta,x0,listx(i),listx(i+1),ax,bx,cx,dx);%up
             b((-1+i)*n^2-n^2*nitx+2*n^2*nitx*nity+a+1+beta*(n0+1))=-legnint1dgbab(2,-1,a,beta,x0,listx(i),listx(i+1),ax,bx,cx,dx);%down         
         end
     end
    end

%eq3

    for i=1:nitx*nity
        for l=0:n-1
            for k=0:n-1
                if (mod(i,nitx)==0)
                    b(2*nitx*nity*n^2+(i-1)*n^2+k+1+(n)*l)=legnintabcd(k,l,x,listx(lex-1),listx(lex),listy(ley-(floor(abs(i-1)/nitx)+1)),listy(ley-(floor(abs(i-1)/nitx))));%right 1 column %wrong2 nit->nitx
                else
                    b(2*nitx*nity*n^2+(i-1)*n^2+k+1+(n)*l)=legnintabcd(k,l,x,listx(1+mod(i-1,lex-1)),listx(1+mod(i,lex-1)),listy(ley-(floor(abs(i-1)/nitx)+1)),listy(ley-(floor(abs(i-1)/nitx))));%wrong1 change listx(1+mod(i-1,lex-1)),listx(1+mod(i,lex-1))
                end
            end
        end
    end
%block in four corners
    for l=0:n-1
             for k=0:n-1
                 b(2*nitx*nity*n^2+k+1+n*l)=legnintabcd(k,l,x,listx(1),listx(2),listy(ley-1),listy(ley))+c11*(+legnint1dgbab(2,1,k,l,x0,listx(1),listx(2),ax,bx,cx,dx)+legnint1dgbab(1,-1,l,k,x0,listy(ley-1),listy(ley),ax,bx,cx,dx));% 1 block
                 b(2*nitx*nity*n^2+(nitx-1)*n^2+k+1+n*l)=legnintabcd(k,l,x,listx(lex-1),listx(lex),listy(ley-1),listy(ley))+c11*(legnint1dgbab(1,1,l,k,x0,listy(ley-1),listy(ley),ax,bx,cx,dx)+legnint1dgbab(2,1,k,l,x0,listx(lex-1),listx(lex),ax,bx,cx,dx));% nit block
                 b(2*nitx*nity*n^2+(nity-1)*nitx*n^2+k+1+n*l)=legnintabcd(k,l,x,listx(1),listx(2),listy(1),listy(2))+c11*(legnint1dgbab(1,-1,l,k,x0,listy(1),listy(2),ax,bx,cx,dx)+legnint1dgbab(2,-1,k,l,x0,listx(1),listx(2),ax,bx,cx,dx));% nit*(nit-1)+1
                 b(3*nitx*nity*n^2-n^2+k+1+n*l)=legnintabcd(k,l,x,listx(lex-1),listx(lex),listy(1),listy(2))+c11*(legnint1dgbab(1,1,l,k,x0,listy(1),listy(2),ax,bx,cx,dx)+legnint1dgbab(2,-1,k,l,x0,listx(lex-1),listx(lex),ax,bx,cx,dx));% nit^2
             end
    end
    for i=1:nitx-2
        for l=0:n-1
            for k=0:n-1
                 b(2*nitx*nity*n^2+i*n^2+k+1+(n)*l)=b(2*nitx*nity*n^2+i*n^2+k+1+(n)*l)+c11*legnint1dgbab(2,1,k,l,x0,listx(i+1),listx(i+2),ax,bx,cx,dx);%up  legnintabcd(k,l,x,-1,0,0,1)+
                 b(2*nitx*nity*n^2+nitx*(nity-1)*n^2+n^2+(i-1)*n^2+k+1+(n)*l)=b(2*nitx*nity*n^2+nitx*(nity-1)*n^2+n^2+(i-1)*n^2+k+1+(n)*l)+c11*legnint1dgbab(2,-1,k,l,x0,listx(i+1),listx(i+2),ax,bx,cx,dx);%down  legnintabcd(k,l,x,-1,0,-1,0)+
            end
        end
    end
    for i=1:nity-2
        for l=0:n-1
            for k=0:n-1
                 b(2*nitx*nity*n^2+nitx*i*n^2+k+1+(n)*l)=b(2*nitx*nity*n^2+nitx*i*n^2+k+1+(n)*l)+c11*legnint1dgbab(1,-1,l,k,x0,listy(ley-i-1),listy(ley-i),ax,bx,cx,dx);%left  legnintabcd(k,l,x,0,1,0,1)+
                 b(2*nitx*nity*n^2+nitx*i*n^2+(nitx-1)*n^2+k+1+(n)*l)=b(2*nitx*nity*n^2+nitx*i*n^2+(nitx-1)*n^2+k+1+(n)*l)+c11*legnint1dgbab(1,1,l,k,x0,listy(ley-i-1),listy(ley-i),ax,bx,cx,dx);%right  legnintabcd(k,l,x,0,1,-1,0)+
            end
        end
    end

end
