function s=legnint1dgbab(comp,val,m,t,x,aa,bb,ax,bx,cx,dx)
% m is the order of "legendre polynomial" in int(f*leg(j))
% x is the max [order of f in x ,order of f in y]
% t is the order of "legendre polynomial( Pt )" in g(x0,y0)=Pt(x0)*g(x0,y0) or
% g(x0,y0)=Pt(y0)*g(x0,y0)
% comp->component in g(x,y) be fixed and the value type in val
% the following n is the total degree of f*leg(j) polynomial of one variable
% aa,bb means the range of int(f*leg) in aa,bb interval
% ax is the left endpoint of block
% bx is the right endpoint of block
% cx is the down endpoint of block
% dx is the up endpoint of block
n=m+x;
if mod(n,2)==0
    n1=ceil((n+1)/2);
else
    n1=ceil(n/2);
end

[A,B]=gauleg(n1);
C=legtable(A,m);
D=C(m+1,:);
A=A*((bb-aa)/2)+(aa+bb)/2;%node
B=B*(bb-aa)/2;%weight
s=0;
if ((comp==1)&(val==1))
    for i=1:n1
    s=s+B(i)*g(bx,A(i))*D(i);
    end
elseif ((comp==1)&(val==-1))
    for i=1:n1
    s=s+B(i)*(-1)^(t)*g(ax,A(i))*D(i);
    end
elseif ((comp==2)&(val==1))
    for i=1:n1
    s=s+B(i)*g(A(i),dx)*D(i);
    end
elseif ((comp==2)&(val==-1))
    for i=1:n1
    s=s+B(i)*(-1)^(t)*g(A(i),cx)*D(i);
    end
    
end
return;
