function p=polythree(z,x1,y1)
% legendre polynomial coefficient start as a(0,0),a(1,0),a(2,0),a(0,1),a(1,1).
% a(i,j)=legendre poly degree i in x *legendre poly degree j in y 
% max degree is 6,if your length(x)>6,you have to define k to include the
% degree you need.
% remember to claim syms x,y before use this function and we can replace x
% with (x-1/2)*2.


n=length(z);
n1=ceil(sqrt(n));
if (n1^2>n)
    for i=n+1:n1^2
        z(i)=0;
    end
end

k=zeros(7,7);
k(1,1)=1;
k(2,2)=1;
k(3,1)=-1/2;
k(3,3)=3/2;
k(4,2)=-3/2;
k(4,4)=5/2;
k(5,1)=3/8;
k(5,3)=-30/8;
k(5,5)=35/8;
k(6,2)=15/8;
k(6,4)=-70/8;
k(6,6)=63/8;
k(7,1)=-5/16;
k(7,3)=105/16;
k(7,5)=-315/16;
k(7,7)=231/16;
k=fliplr(k);
s=0;
for j=1:n1
    for i=1:n1
    s=s+z(i+n1*(j-1))*polyval(k(i,:),x1)*polyval(k(j,:),y1);
    end
end
p=s;
return;